/**
 * ConvertKit Form Divi Module.
 */
class ConvertKitForm extends React.Component {

	/**
	 * The Divi module name. Must match the slug defined in
	 * the PHP class ConvertKit_Divi_Module_Form.
	 * 
	 * @since 	2.5.6
	 */
	static slug = 'convertkit_form';

	/**
	 * Renders the frontend output for this module.
	 * 
	 * @since 	2.5.6
	 */
	render() {

		// Show instructions if no form selected.
		if ( this.props.form.length === 0 ) {
			// Return module with text.
			return React.createElement( 'div', {
				className: 'convertkit-divi-module'
			}, 'Select a Form using the Form option in this module.' );
		}

		// Get selected form.
		const form = window.ConvertkitDiviBuilderData.form.fields.form.data.forms[ this.props.form ];

		// Return module with text.
		return React.createElement( 'div', {
			className: 'convertkit-divi-module'
		}, 'ConvertKit Form "' + form.name + '" selected. View on the frontend site to see the form.' );

	}

}

/**
 * Register Divi modules when the Divi Builder API is ready.
 * 
 * @since 	2.5.6
 * 
 * @param 	object 	event 	Event.
 * @param 	object 	API 	Divi Buidler API.
 */
jQuery( window ).on( 'et_builder_api_ready', function ( event, API ) {

	// Register Divi modules.
  	API.registerModules( [
  		ConvertKitForm
  	] );

} );